
#include "ot4xb.ch" // => ot4xb.dll => www.xbwin.com

#ifndef CRLF
   #define CRLF chr(13)+chr(10)
#endif


* Klasse zum sequentiellen Einlesen groer Dateien

#IF .t.       // zum Einbinden in eigenes Projekt, .f. setzen !

procedure main
   local nZeile := 0
   local cZeile := ""
   local nSize, nBytes := 0
   local nDauer, cFile, oTR

   cls

*  cFile := "test.txt"
   cFile := "train_V2.csv"

*  if ! file(cFile)
*     @ 1,1 say "create test file "+cFile
*     set console off
*     set alternate to (cFile)
*     set alternate on
*     for nZeile := 1 to 2000000
*         ?? "Zeile: ",nZeile," weitere Infos bis etwa 100 Zeichen lskdjlsd sa dlfkjsa doweirhj adlkfj saldkfjwoeijrh"+CRLF
*         if nZeile % 1000 = 0
*            @2,2 say "Zeile "+str(nZeile)
*         endif
*     next
*     @ 2,2 say "Zeile "+str(nZeile-1)
*     set alternate to
*  endif
   set console on

   nZeile := 0

   oTR := HBTextReader( cFile ) // per Funktion

   * oTR := HBTxtReader():new( cFile ) // oder Klassentypisch !

   if oTR:FError() <> 0
      @ 5,1 say "Fehler beim Datei ffnen: "+oTR:ErrMsg()
      inkey(30)
      quit
   endif
   nSize := oTR:FSize()
   @ 1,1 say  "Testdatei sequentiell einlesen, Dateityp: "+oTR:FileType()
   @ 3,1 say  "Dateigre      "+transform(nSize,"###,###,###,###,###")

   nDauer := seconds()

   do while ! oTR:EOF()

      cZeile := oTR:GetLine() // aktuelle Zeile einlesen, Zeiger intern auf nchste Zeile setzen !

      nZeile++                // oder oTR:RecNo() // beides mglich !

      nBytes += len(cZeile)+iif(oTR:IsCrLf(),2,1) // CR+LF = 2 Byte

      // CSV Dateien mit ";" Trenner knnen zeilenweise ganz einfach in ein Array aufgeteilt werden:
      //
      // aZeile := Tokenize(cZeile, ";" ) // ot4xb.dll einbinden !

      if nZeile % 1000 = 0    //  je nach Anzahl alle 100 oder 1000 Stze aufrufen
         @ 5,1 say  "gelesene Bytes    "+transform(nBytes,  "###,###,###,###,###")
         @ 6,1 say  "gelesene Zeilen   "+transform(nZeile,  "###,###,###,###,###")
         @ 7,1 say  "interne Zeilennr. "+transform(oTR:RecNo(),"###,###,###,###,###")
         @ 8,1 say  "Datenzeile:       "+left(cZeile,20)
      endif

   enddo

   oTR:Destroy()

   nDauer := seconds() - nDauer

   @ 5,1 say  "gelesene Bytes    "+transform(nBytes,"###,###,###,###,###")
   @ 6,1 say  "gelesene Zeilen   "+transform(nZeile,"###,###,###,###,###")

   @10,1 say  "Dauer:            "+transform(nDauer,"###,###,###,###,###")+" Sekunden => "+str(nZeile/nDauer)+" Zeilen / Sekunde"
   @11,1 say  "                                                "+str(nZeile/nDauer/104)+" Datenstze / Sekunde"

   @13,1 say  "ENDE, bitte Taste drcken ..."

   wait

return

#endif

* Klasse zum sequentiellen Einlesen groer Dateien
* Da die Blockgre auf 4 KB begrenzt ist, kann man auch einfach die Zeilen ausschneiden.

#include "Fileio.ch"

function HBTextReader( cFile )
   local oTR := HBTxtReader():new( cFile )
return oTR

CLASS HBTxtReader
  PROTECTED:
     VAR nH
     VAR nLastError
     VAR IsEOF           // Buffer hat beim Einlesen EOF erreicht, Zeilen knnen noch da sein !
     VAR cRest
     VAR nBufferBytes    // Anzahl der gelesenen Byte im Buffer
     VAR cCRLF, nLenCRLF // Unix/Linux nur chr(10) = 1 Byte, Windows chr(13)+chr(10) = 2 Byte
     VAR Line
     METHOD ReadBuffer

  EXPORTED:
     METHOD Init
     METHOD Destroy
     METHOD GetLine
     METHOD GoTop
     METHOD FSize
     METHOD FError
     METHOD ErrMsg
     METHOD EOF
     METHOD IsCrLf
     METHOD IsUnix
     METHOD IsMac
     INLINE METHOD RecNo    ; RETURN ::line
     INLINE METHOD LenCrLf  ; RETURN ::nLenCRLF
     METHOD FileType

ENDCLASS

METHOD HBTxtReader:Init( cFileName )       // ffnet die Datei zum Lesen
   ::nLastError   := 0
   ::cRest        := ""
   ::nBufferBytes := 0
   ::Line         := 0
   ::nH    := fopen( cFileName , FO_READ + FO_SHARED )
   if ::nH = -1
      ::nLastError := FError()
      ::IsEOF      := .t.
   else
      ::IsEOF      := .f.
      ::ReadBuffer()
      do case
         case chr(13)+chr(10) $ ::cRest // Windows etc.
              ::cCRLF    := chr(13)+chr(10)
              ::nLenCRLF := 2
         case chr(10)         $ ::cRest // Unix
              ::cCRLF    := chr(10)
              ::nLenCRLF := 1
         case chr(13)         $ ::cRest // Mac
              ::cCRLF    := chr(13)
              ::nLenCRLF := 1
      end
   endif
RETURN SELF

METHOD HBTxtReader:Destroy()
   if ::nH <> -1
      FClose(::nH)
      ::nH := -1
   endif
   ::cRest := ""
RETURN SELF

METHOD HBTxtReader:ReadBuffer()
   local cBuffer, nBufferLen, nBytes
   if ::nH > -1
      nBufferLen := 4096
      cBuffer    := space(nBufferLen)
      nBytes     := FRead( ::nH, @cBuffer, nBufferLen)
      cBuffer    := StrTran(cBuffer,chr(26)," ")
      ::nBufferBytes += nBytes
      if nBufferLen = nBytes // mitten in Datei
         ::cRest += cBuffer
      else
         ::cRest += left(cBuffer,nBytes)
         ::IsEOF := .t.
         if FError() <> 0
            ::nLastError := FError()
         endif
      endif
      cBuffer := ""
   endif
Return

METHOD HBTxtReader:GetLine()
   local nPosCRLF
   local cLine := ""
   do while ! ::cCRLF $ ::cRest .and. ! ::IsEof  // Buffer einlesen, bis wir neue Zeilen haben oder die Datei gelesen wurde
      ::ReadBuffer()
   enddo
   nPosCRLF := at( ::cCRLF, ::cRest)
   if nPosCRLF > 0 // es gibt noch eine komplette Zeile, zurckgeben und krzen
      cLine   := left(::cRest,nPosCRLF-1)
      ::cRest := substr(::cRest,nPosCRLF+::nLenCRLF)
   else
      cLine   := ::cRest
      ::cRest := ""
   endif
   ::Line++
return cLine

METHOD HBTxtReader:GoTop()
   if ::nH <> -1
      FSeek(::nH, 0 , FS_SET )
   endif
   ::cRest   := ""  // zwingt zum neu einlesen
   ::Line    := 0
   ::ReadBuffer()
return NIL

METHOD HBTxtReader:FSize()
   local nSize := 0
   if ::nH <> -1
      nSize := FSize(::nH)
   endif
RETURN nSize

METHOD HBTxtReader:FError()
RETURN ::nLastError

METHOD HBTxtReader:EOF()
RETURN ::IsEOF .and. empty(::cRest)

METHOD HBTxtReader:IsCrLf()
RETURN (::cCRLF == chr(13)+chr(10))

METHOD HBTxtReader:IsUnix()
RETURN (::cCRLF == chr(10))

METHOD HBTxtReader:IsMac()
RETURN (::cCRLF == chr(13))

METHOD HBTxtReader:ErrMsg()
RETURN DosErrorMessage(::nLastError)

METHOD HBTxtReader:FileType()
   local cTxt := ""
   do case
      case ::IsCrLf()
           cTxt := "CRLF"
      case ::IsUnix()
           cTxt := "UNIX/Linux"
      case ::IsMac()
           cTxt := "MAC"
   end
return cTxt
